(* THIS FILE IS AUTOGENERATED -> DO NOT EDIT OR YOUR EDITS WILL BE LOST! *)
let introspect_xml = "
<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">
<node name=\"/\">
  <!--~~~~~~~~~~~~~~~~~~~~~~
  ~~~~  DBus Interface  ~~~~
  ~~~~~~~~~~~~~~~~~~~~~~~-->
  <interface name=\"com.citrix.xenclient.db\">
    <!--~~~~~~~~~~~~~~~~~~~~~~
    ~~~~  DBus Methods    ~~~~
    ~~~~~~~~~~~~~~~~~~~~~~~-->
    <method name=\"dump\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"s\" direction=\"out\"/>
    </method>
    <method name=\"exists\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"ex\" type=\"b\" direction=\"out\"/>
    </method>
    <method name=\"inject\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"s\" direction=\"in\"/>
    </method>
    <method name=\"list\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"as\" direction=\"out\"/>
    </method>
    <method name=\"read\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"s\" direction=\"out\"/>
    </method>
    <method name=\"read_binary\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"ay\" direction=\"out\"/>
    </method>
    <method name=\"rm\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
    </method>
    <method name=\"write\">
      <arg name=\"path\" type=\"s\" direction=\"in\"/>
      <arg name=\"value\" type=\"s\" direction=\"in\"/>
    </method>
  </interface>
</node>

"

let dbus_filter obj_path_ bus msg =
	let params     = DBus.Message.get msg in
	let msg_method = match DBus.Message.get_member msg with None -> "" | Some m -> m in
	let interface  = match DBus.Message.get_interface msg with None -> "" | Some i -> i in
	let path       = match DBus.Message.get_path msg with None -> "" | Some p -> p in
	let process_method_call msg =
		Some (match interface, msg_method, params with
		      | "org.freedesktop.DBus.Introspectable", "Introspect", _ ->
				let m = DBus.Message.new_method_return msg in
				DBus.Message.append m [DBus.String introspect_xml];
				m
			| "com.citrix.xenclient.db", "dump", args -> (try 
				let [DBus.String path] = args in
				let (out_1) = Db_methods.com_citrix_xenclient_db_dump msg path in
				let reply = DBus.Message.new_method_return msg in
				DBus.Message.append reply [DBus.String out_1];
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "exists", args -> (try 
				let [DBus.String path] = args in
				let (out_1) = Db_methods.com_citrix_xenclient_db_exists msg path in
				let reply = DBus.Message.new_method_return msg in
				DBus.Message.append reply [DBus.Bool out_1];
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "inject", args -> (try 
				let [DBus.String path; DBus.String value] = args in
				let () = Db_methods.com_citrix_xenclient_db_inject msg path value in
				let reply = DBus.Message.new_method_return msg in
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "list", args -> (try 
				let [DBus.String path] = args in
				let (out_1) = Db_methods.com_citrix_xenclient_db_list msg path in
				let reply = DBus.Message.new_method_return msg in
				DBus.Message.append reply [DBus.Array (DBus.Strings out_1)];
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "read", args -> (try 
				let [DBus.String path] = args in
				let (out_1) = Db_methods.com_citrix_xenclient_db_read msg path in
				let reply = DBus.Message.new_method_return msg in
				DBus.Message.append reply [DBus.String out_1];
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "read_binary", args -> (try 
				let [DBus.String path] = args in
				let (out_1) = Db_methods.com_citrix_xenclient_db_read_binary msg path in
				let reply = DBus.Message.new_method_return msg in
				DBus.Message.append reply [DBus.Array (DBus.Bytes out_1)];
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "rm", args -> (try 
				let [DBus.String path] = args in
				let () = Db_methods.com_citrix_xenclient_db_rm msg path in
				let reply = DBus.Message.new_method_return msg in
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

			| "com.citrix.xenclient.db", "write", args -> (try 
				let [DBus.String path; DBus.String value] = args in
				let () = Db_methods.com_citrix_xenclient_db_write msg path value in
				let reply = DBus.Message.new_method_return msg in
				reply
				 with Match_failure _ -> DBus.Message.new_error msg DBus.ERR_INVALID_SIGNATURE "invalid arguments"
				    | Failure s -> DBus.Message.new_error msg DBus.ERR_FAILED s
				    | _ -> DBus.Message.new_error msg DBus.ERR_FAILED "exception occured")

		      | _, _, _ -> DBus.Message.new_error msg DBus.ERR_UNKNOWN_METHOD "no such method"
		     )
	in
	let process_message msg =
		if path <> obj_path_
		then None
		else (
			match DBus.Message.get_type msg with
			| DBus.Message.Method_call ->
				  process_method_call msg
			| _ -> None
		)
	in
	let reply = process_message msg in
	(match reply with
	| Some reply -> 
		  ignore (DBus.Connection.send bus reply);
		  DBus.Connection.flush bus
	| None -> ());
	true

let db_export_dbus obj_path bus =
	DBus.Bus.add_match bus ("type='method_call',interface='com.citrix.xenclient.db',path='"^obj_path^"'") false;
	DBus.Bus.add_match bus ("type='method_call',interface='org.freedesktop.DBus.Introspectable',path='"^obj_path^"'") false;
	DBus.Connection.flush bus;
	DBus.Connection.add_filter bus (dbus_filter obj_path)

