(* THIS FILE IS AUTOGENERATED -> DO NOT EDIT OR YOUR EDITS WILL BE LOST! *)
open DBus

let bus = DBus.Bus.get DBus.Bus.System
let default_timeout = 1000 * 3600 (* one hour *)

let call_dbus ~timeout ~service ~obj ~interface ~member ~args =
	let m = DBus.Message.new_method_call service obj interface member in
	ignore (DBus.Message.append m args);
	DBus.Connection.send_with_reply_and_block bus m ( if timeout>0 then timeout * 1000 else default_timeout )

let org_freedesktop_DBus_Introspectable_Introspect ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus.Introspectable" ~member:"Introspect" ~args:[  ] in
	match Message.get reply with
	| [ DBus.String out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_Hello ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"Hello" ~args:[  ] in
	match Message.get reply with
	| [ DBus.String out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_RequestName ?(timeout=(-1)) service_ obj_path_ a1 a2 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"RequestName" ~args:[ DBus.String a1; DBus.UInt32 a2 ] in
	match Message.get reply with
	| [ DBus.UInt32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_ReleaseName ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"ReleaseName" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.UInt32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_StartServiceByName ?(timeout=(-1)) service_ obj_path_ a1 a2 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"StartServiceByName" ~args:[ DBus.String a1; DBus.UInt32 a2 ] in
	match Message.get reply with
	| [ DBus.UInt32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_UpdateActivationEnvironment ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"UpdateActivationEnvironment" ~args:[ DBus.Array (DBus.Dicts ((DBus.SigString,DBus.SigString),a1)) ] in
	match Message.get reply with
	| [  ] -> ()
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_NameHasOwner ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"NameHasOwner" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.Bool out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_ListNames ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"ListNames" ~args:[  ] in
	match Message.get reply with
	| [ DBus.Array (DBus.Strings out_1) ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_ListActivatableNames ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"ListActivatableNames" ~args:[  ] in
	match Message.get reply with
	| [ DBus.Array (DBus.Strings out_1) ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_AddMatch ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"AddMatch" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [  ] -> ()
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_RemoveMatch ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"RemoveMatch" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [  ] -> ()
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetNameOwner ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetNameOwner" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.String out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_ListQueuedOwners ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"ListQueuedOwners" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.Array (DBus.Strings out_1) ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetConnectionUnixUser ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetConnectionUnixUser" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.UInt32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetConnectionUnixProcessID ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetConnectionUnixProcessID" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.UInt32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetConnectionDOMID ?(timeout=(-1)) service_ obj_path_ sender = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetConnectionDOMID" ~args:[ DBus.String sender ] in
	match Message.get reply with
	| [ DBus.Int32 out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetAdtAuditSessionData ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetAdtAuditSessionData" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.Array (DBus.Bytes out_1) ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetConnectionSELinuxSecurityContext ?(timeout=(-1)) service_ obj_path_ a1 = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetConnectionSELinuxSecurityContext" ~args:[ DBus.String a1 ] in
	match Message.get reply with
	| [ DBus.Array (DBus.Bytes out_1) ] -> (out_1)
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_ReloadConfig ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"ReloadConfig" ~args:[  ] in
	match Message.get reply with
	| [  ] -> ()
	| _ -> failwith "unexpected reply"

let org_freedesktop_DBus_GetId ?(timeout=(-1)) service_ obj_path_  = 
	let reply = call_dbus ~timeout ~service:service_ ~obj:obj_path_ ~interface:"org.freedesktop.DBus" ~member:"GetId" ~args:[  ] in
	match Message.get reply with
	| [ DBus.String out_1 ] -> (out_1)
	| _ -> failwith "unexpected reply"


